using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using HySoft.DBUtility;
using System.Data;
using System.Data.SqlClient;

namespace HySoft.BaseCallCenter.DAL
{
    /// <summary>
    /// 数据访问类:T_Sys_CallOptLogs
    /// </summary>
    public partial class T_Sys_CallOptLogs
    {
        public T_Sys_CallOptLogs()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Sys_CallOptLogs");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
					new SqlParameter("@F_Id", SqlDbType.Int,4)
			};
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(HySoft.BaseCallCenter.Model.T_Sys_CallOptLogs model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Sys_CallOptLogs(");
            strSql.Append("F_OptBy,F_OptOn,F_OptName,F_Type,F_Name,F_Descript,F_State)");
            strSql.Append(" values (");
            strSql.Append("@F_OptBy,@F_OptOn,@F_OptName,@F_Type,@F_Name,@F_Descript,@F_State)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
					new SqlParameter("@F_OptBy", SqlDbType.Int,4),
					new SqlParameter("@F_OptOn", SqlDbType.DateTime),
					new SqlParameter("@F_OptName", SqlDbType.NVarChar,50),
					new SqlParameter("@F_Type", SqlDbType.SmallInt,2),
					new SqlParameter("@F_Name", SqlDbType.NVarChar,50),
					new SqlParameter("@F_Descript", SqlDbType.NVarChar,2000),
					new SqlParameter("@F_State", SqlDbType.SmallInt,2)};
            parameters[0].Value = model.F_OptBy;
            parameters[1].Value = model.F_OptOn;
            parameters[2].Value = model.F_OptName;
            parameters[3].Value = model.F_Type;
            parameters[4].Value = model.F_Name;
            parameters[5].Value = model.F_Descript;
            parameters[6].Value = model.F_State;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(HySoft.BaseCallCenter.Model.T_Sys_CallOptLogs model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Sys_CallOptLogs set ");
            strSql.Append("F_OptBy=@F_OptBy,");
            strSql.Append("F_OptOn=@F_OptOn,");
            strSql.Append("F_OptName=@F_OptName,");
            strSql.Append("F_Type=@F_Type,");
            strSql.Append("F_Name=@F_Name,");
            strSql.Append("F_Descript=@F_Descript,");
            strSql.Append("F_State=@F_State");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
					new SqlParameter("@F_OptBy", SqlDbType.Int,4),
					new SqlParameter("@F_OptOn", SqlDbType.DateTime),
					new SqlParameter("@F_OptName", SqlDbType.NVarChar,50),
					new SqlParameter("@F_Type", SqlDbType.SmallInt,2),
					new SqlParameter("@F_Name", SqlDbType.NVarChar,50),
					new SqlParameter("@F_Descript", SqlDbType.NVarChar,2000),
					new SqlParameter("@F_State", SqlDbType.SmallInt,2),
					new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.F_OptBy;
            parameters[1].Value = model.F_OptOn;
            parameters[2].Value = model.F_OptName;
            parameters[3].Value = model.F_Type;
            parameters[4].Value = model.F_Name;
            parameters[5].Value = model.F_Descript;
            parameters[6].Value = model.F_State;
            parameters[7].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_CallOptLogs ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
					new SqlParameter("@F_Id", SqlDbType.Int,4)
			};
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Sys_CallOptLogs ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public HySoft.BaseCallCenter.Model.T_Sys_CallOptLogs GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_OptBy,F_OptOn,F_OptName,F_Type,F_Name,F_Descript,F_State from T_Sys_CallOptLogs ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
					new SqlParameter("@F_Id", SqlDbType.Int,4)
			};
            parameters[0].Value = F_Id;

            HySoft.BaseCallCenter.Model.T_Sys_CallOptLogs model = new HySoft.BaseCallCenter.Model.T_Sys_CallOptLogs();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public HySoft.BaseCallCenter.Model.T_Sys_CallOptLogs DataRowToModel(DataRow row)
        {
            HySoft.BaseCallCenter.Model.T_Sys_CallOptLogs model = new HySoft.BaseCallCenter.Model.T_Sys_CallOptLogs();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["F_OptBy"] != null && row["F_OptBy"].ToString() != "")
                {
                    model.F_OptBy = int.Parse(row["F_OptBy"].ToString());
                }
                if (row["F_OptOn"] != null && row["F_OptOn"].ToString() != "")
                {
                    model.F_OptOn = DateTime.Parse(row["F_OptOn"].ToString());
                }
                if (row["F_OptName"] != null)
                {
                    model.F_OptName = row["F_OptName"].ToString();
                }
                if (row["F_Type"] != null && row["F_Type"].ToString() != "")
                {
                    model.F_Type = int.Parse(row["F_Type"].ToString());
                }
                if (row["F_Name"] != null)
                {
                    model.F_Name = row["F_Name"].ToString();
                }
                if (row["F_Descript"] != null)
                {
                    model.F_Descript = row["F_Descript"].ToString();
                }
                if (row["F_State"] != null && row["F_State"].ToString() != "")
                {
                    model.F_State = int.Parse(row["F_State"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_OptBy,F_OptOn,F_OptName,F_Type,F_Name,F_Descript,F_State ");
            strSql.Append(" FROM T_Sys_CallOptLogs ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_OptBy,F_OptOn,F_OptName,F_Type,F_Name,F_Descript,F_State ");
            strSql.Append(" FROM T_Sys_CallOptLogs ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Sys_CallOptLogs ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Sys_CallOptLogs T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

      

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }




}
